#! /usr/local/bin/perl

while ( <> ) {
    s/\#.*$//;
    next if /^\s*$/;
    /^\s*(\S*)\s*\((.*?)\)\s*$/;
    $type[$i]{'name'} = $1;
    $ps = $2;
    $_ = $1;  tr/a-z/A-Z/;  $type[$i]{'NAME'} = $_;
    $j = 0;
    while ( $ps =~ s/\s*(\S*)\s+(\S*)\s*(,|$)// ) {
	$type[$i]{'params'}[$j]{'type'} = $1;
	$type[$i]{'params'}[$j]{'name'} = $2;
	$j++;
    }
    $type[$i]{'nbparams'} = $j;
    $i++;
}

$nbtypes = $i;

open F, ">obj_enum.h" or die "Can't open file.";
print F "/* This file is automatically generated.  Do not edit! */\n\n";
print F "enum object_type_e {\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    printf F "  O_%s,\n", $type[$i]{'NAME'};
}
print F "  O_INVALID /* Stupid C standard does not allow comma at end */\n";
print F "};\n";
close F;

open F, ">obj_struct.h" or die "Can't open file.";
print F "/* This file is automatically generated.  Do not edit! */\n\n";
print F "struct generic_object_s {\n  enum object_type_e t;\n};\n\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    print F "\n" if $i;
    printf F "struct %s_object_s {\n", $type[$i]{'name'};
    printf F ("  enum object_type_e t;  /* Must be O_%s */\n",
	      $type[$i]{'NAME'});
    for ( $j=0 ; $j<$type[$i]{'nbparams'} ; $j++ ) {
	printf F ("  %s %s;\n",
		  $type[$i]{'params'}[$j]{'type'},
		  $type[$i]{'params'}[$j]{'name'});
    }
    print F "};\n";
}
print F "\nunion object_u {\n  struct generic_object_s generic;\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    printf F ("  struct %s_object_s %s;\n",
	      $type[$i]{'name'},
	      $type[$i]{'name'});
}
print F "};\n";
close F;

open F, ">o_defs.h" or die "Can't open file.";
print F "/* This file is automatically generated.  Do not edit! */\n\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    for ( $j=0 ; $j<$type[$i]{'nbparams'} ; $j++ ) {
	printf F ("%s o_%s_%s (object_t obj);\n",
		  $type[$i]{'params'}[$j]{'type'},
		  $type[$i]{'name'},
		  $type[$i]{'params'}[$j]{'name'});
    }
}
close F;

open F, ">o_bodies.c" or die "Can't open file.";
print F "/* This file is automatically generated.  Do not edit! */\n\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    for ( $j=0 ; $j<$type[$i]{'nbparams'} ; $j++ ) {
	print F "\n" if $i;
	printf F ("%s\no_%s_%s (object_t obj)\n{\n",
		  $type[$i]{'params'}[$j]{'type'},
		  $type[$i]{'name'},
		  $type[$i]{'params'}[$j]{'name'});
	printf F ("  CHKTYPE (obj, O_%s);\n",
		  $type[$i]{'NAME'});
	printf F ("  return obj->%s.%s;\n",
		  $type[$i]{'name'},
		  $type[$i]{'params'}[$j]{'name'});
	print F "}\n";
    }
}
close F;

open F, ">new_defs.h" or die "Can't open file.";
print F "/* This file is automatically generated.  Do not edit! */\n\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    printf F "object_t new_%s (", $type[$i]{'name'};
    for ( $j=0 ; $j<$type[$i]{'nbparams'} ; $j++ ) {
	print F ", " if $j;
	printf F ("%s %s",
		  $type[$i]{'params'}[$j]{'type'},
		  $type[$i]{'params'}[$j]{'name'});
    }
    print F "void" unless $j;
    print F ");\n";
}
close F;

open F, ">new_bodies.c" or die "Can't open file.";
print F "/* This file is automatically generated.  Do not edit! */\n\n";
for ( $i=0 ; $i<$nbtypes ; $i++ ) {
    print F "\n" if $i;
    printf F "object_t\nnew_%s (", $type[$i]{'name'};
    for ( $j=0 ; $j<$type[$i]{'nbparams'} ; $j++ ) {
	print F ", " if $j;
	printf F ("%s %s",
		  $type[$i]{'params'}[$j]{'type'},
		  $type[$i]{'params'}[$j]{'name'});
    }
    print F "void" unless $j;
    print F ")\n{\n  object_t obj;\n\n";
    printf F "  obj = new_object (O_%s);\n", $type[$i]{'NAME'};
    for ( $j=0 ; $j<$type[$i]{'nbparams'} ; $j++ ) {
	printf F ("  obj->%s.%s = %s;\n",
		  $type[$i]{'name'},
		  $type[$i]{'params'}[$j]{'name'},
		  $type[$i]{'params'}[$j]{'name'});
    }
    print F "  return obj;\n}\n";
}
close F;
