%{
#include "flang.h"

#define YYERROR_VERBOSE
%}

%union {
  hashv_t ident;
  object_t val;
}

%token <ident> TOK_IDENT
%token TOK_LPAREN
%token TOK_RPAREN
%token TOK_SEMICOLON
%token TOK_ARROW
%token TOK_EOF

%type <val> expr
%type <val> simple_expr

%start main

%%

main:
	expr				{ mainprog = $1; }
;

expr:
	simple_expr			{ $$ = $1; }
      | expr simple_expr		{ $$ = new_apply ($1, $2); }
      | expr TOK_SEMICOLON expr		{ $$ = new_progn ($1, $3); }
;

simple_expr:
	TOK_LPAREN TOK_RPAREN		{ $$ = new_quote (new_unit ()); }
      | TOK_IDENT			{ $$ = new_var ($1); }
      | TOK_IDENT TOK_ARROW expr	{ $$ = new_lambda ($1, $3); }
      | TOK_LPAREN expr TOK_RPAREN	{ $$ = $2; }
;

%%

void
yyerror (char *msg)
{
  error (msg);
}
